CatBin <-
function (startX, endX, Avg=1, lum=4, sizePts=2, binPts=15,modulo=1440, startData=1, myData) {
  
  #if (length(myData[,1])<3*modulo)
  #  print(paste(binPts,"There must be at least 3 days of data"))    #   stop
  
  newMinPerBin <- binPts*sizePts    
  if (floor(modulo/(newMinPerBin))!=(modulo/newMinPerBin)){
    #  bin size has to be a multiple of modulo so days can be split evenly
    stop(paste(binPts," is not a valid binning size as binPts*sizePts does not divide equally into modulo=",modulo))
  }
  
  dataPts<-(modulo/sizePts)*floor(length(myData[,endX])/(modulo/sizePts));  # #data pts that gives FULL bins only
  endData <- startData+dataPts-1
  dayPts <- modulo/newMinPerBin;    # number of dataPts in a day after binning happens
  dayCnt <- floor(dataPts/(modulo/newMinPerBin))   # number of days of dayPts in dataPts  --after binning
  dataCnt <- floor(dataPts/(dayPts*binPts));   # rnd toward 0:  dataPts w/ full bins; 
  #cat("dataPts",dataPts,"dayPts",dayPts,"binPts",binPts,"dataCnt",dataCnt,"\n")
  #t<-1:1:dayPts;
  binsPerDay = modulo/newMinPerBin
  if (dataCnt<3){
    #  need a minimum of 3 days of data
    print(paste(dataPts," There are less than the required minimum of 3 days of data: only ",dataCnt))
  }
  
  animals <- endX-startX+1;
  DataBins <- matrix(data = NA, nrow = dataPts/binPts, ncol = (animals), byrow = FALSE, dimnames = NULL)
  #create an array to hold binned data  -- only as long as new bins
  
  if (binPts>0) {
    sumIndexes <-factor(rep(1:dataPts, each= binPts, length = dataPts))
    for (s in startX:endX){
      DataBins[,(s-startX+1)] <- by(myData[startData:endData,s], sumIndexes, sum)
    }
  } else {
    DataBins[1:dataPts,1:animals] <- myData[startData:endData,startX:endX];   #  no need to bin  -- just use data points;  untested with 1:....
  }
  
  DataList <- vector(length=animals,mode="numeric")
  
  if (Avg)  {    
    DataList <- t(rowSums(DataBins[,1:animals]))/animals;  #  returns a row
    plotCnt <- 1;
  } else {
    DataList <- t(DataBins[,1:animals]);
    plotCnt <- animals;
  }
  TimeBins <- vector(length=dataPts/binPts,mode="character")
  TimeBins2 <- vector(length=dataPts/binPts,mode="character")
  
  TimeBins2<-as.character(format(as.POSIXct(myData[,1], origin="1970-01-01",tz="GMT"),"%Y/%m/%d %H:%M:%S"))
  TimeBins<-TimeBins2[seq(1,endData, by=binPts)]
  if (TRUE==FALSE){
    cat("newMinPerBin",newMinPerBin,"dataPts",dataPts,"dayPts",dayPts,"dayCnt\n",dayCnt,"binsPerDay",binsPerDay,"animals",animals,"endData",endData,"plotCnt\n",plotCnt)
  }
  return(list(newMinPerBin=newMinPerBin,dataPts=dataPts,dayPts=dayPts,dayCnt=dayCnt,binsPerDay=binsPerDay,animals=animals,endData=endData, DataList=DataList,TimeBins=TimeBins,plotCnt=plotCnt))
}
