Wavelet <-
function (startX, endX, Avg=1, lum=4, sizePts=2, binPts=15,myData,fileName) {
#  starting column, ending column, Average or Individual, #minutes between points, # points to bin, # minutes/unit (usually day)
# require delftfews, chron, zoo?
 # require(delftfews)
  require(waveclock)
  modulo = 1440
if (length(myData[,1])<1.5*modulo)
  paste(binPts,"There must be at least 3 days of data")
  #stop(paste(binPts,"There must be at least 3 days of data"))
newMinPerBin = binPts*sizePts    
if (floor(modulo/(newMinPerBin))!=(modulo/newMinPerBin)){
  #  bin size has to be a multiple of modulo so days can be split evenly
  stop(paste(binPts," is not a valid binning size as binPts*sizePts does not divide equally into modulo=1440"))
}
  op<-par()
#NEXT:  why does this have 45.5 bins as the cycle?  oh, bad data!
#NEXT:  function to list all peaks -- put on xlab
  #http://cran.r-project.org/web/packages/Peaks/Peaks.pdf
  #cummax   maxima   which.max gives location of max(getACF$acf)
  #which.max(getACF$acf[(dayPts/2):440])
  
#day <- 24*60;         # number of minutes in a day = 1440  

#myData <- read.table(file.choose(), header=TRUE, sep="\t",skip=0)
# can indicate to skip lines of header
#myData <- read.table("~/Documents/Cathy/Neuroscience papers/capstone/Bartolomucci/Data/stress-bad.txt", header=TRUE, sep="\t",skip=0)

  light <- myData[,lum]         #   get just the luminance vector
  Dark <- light[light<10]       #   get values for darkness
  startDataV <- which(light==Dark[1])       #  get index of first darkness value
  startData <-startDataV[1]
  #startDataV <- stretches(myData[myData<10,lum])
  #startData <- startDataV[1]
dataPts<-binPts*floor(length(myData[-(1:(startData-1)),endX])/binPts);  # #data pts that gives FULL bins only
endData <- startData+dataPts-1
dayPts <- modulo/newMinPerBin;    # number of dataPts in a day after binning happens
dayCnt <- floor(dataPts/(modulo/newMinPerBin))   # number of days of dayPts in dataPts  --after binning
dataCnt <- floor(dataPts/(dayPts*binPts));   # rnd toward 0:  dataPts w/ full bins; 
t<-1:1:dayPts;

animals <- endX-startX+1;
DataBins <- matrix(data = NA, nrow = dataPts/binPts, ncol = (animals), byrow = FALSE, dimnames = NULL)
#create an array to hold binned data  -- only as long as new bins

if (binPts>0) {
    sumIndexes <-factor(rep(1:dataPts, each= binPts, length = dataPts))
    for (s in startX:endX){
    	DataBins[,(s-startX+1)] <- by(myData[startData:endData,s], sumIndexes, sum)
	}
} else {
    DataBins[1:dataPts,animals] <- myData[startData:endData,startX:endX];   #  no need to bin  -- just use data points
}

thisTime <- format(Sys.time(), "%b %d, %Y - %H:%M:%S");
DataList <- vector(length=animals,mode="numeric")

if (Avg)  {    
        DataList <- t(rowSums(DataBins[,1:animals]))/animals;  #  returns a row
        plotCnt <- 1;
} else {
        DataList <- t(DataBins[,1:animals]);
        plotCnt <- animals;
}
  nameVector = paste(" ",names(myData),sep=" ")

for (cnt in 1:plotCnt) {      #  1 plot per animal, for all animals 
  #par(mfrow=c(2,1), oma = c(2,0,0,0),mar=c(2,4,4,2))   #,omi = c(0,0,1,0)) 
  
  waveclock( DataList[cnt,], period = c( 6, 32 ), time.limits = NULL, extend = "reflect",
             noctave = NULL, nvoice = 96, mask.coi = TRUE,
             crc.args = list( seed = 0, nbclimb = 50 ),
             cfamily.args = list( ptile = 0.05, bstep = 5, nbchain = 1000),
             #  chgd ptile from .0005 -> .05 and nbchain from 8000 -> 1000 and it is faster
             crcrec.args = list( compr = 3, epsilon = 0, para = 3, plot = FALSE ),
             xlab = "", ylab = "Period (h)", png = NULL,
             color.palette = heat.colors, mode.col = "green", mode.lty = "solid",
             mode.lwd = 2)


    if (Avg)  {    
        title(paste('Avg across -',animals,'- Animals: ',nameVector[startX],' - ',nameVector[endX],'\nStart:',myData[startData,1],'\n   End:',tail(myData[,1],n=1)),cex=.5,line=1)
    } else {
        title(paste('Animal -',cnt,': ',nameVector[cnt+3],'\nStart:',myData[startData,1],'\n   End:',tail(myData[,1],n=1)),cex=.5,line=1)
    }  
  

  mtext(paste("Time (h)   ",fileName,"   ",thisTime),side=1,line = 3, cex =.8, adj=.9)

}  # end for (cnt in 1:plotCnt)
#savePlot  -- saves to file a png?
  par(op)
end
}
